from portal.service.errors import IncorrectPasswordError
from portal.service.service import find_user


def login_user(gitlab_access_token=None, password=None, username=None):
    if gitlab_access_token:
        return auth_gitlab_access_token(
            username=username,
            gitlab_access_token=gitlab_access_token
        )

    return auth_username_password(username=username, password=password)


def auth_gitlab_access_token(username, gitlab_access_token):
    """Authentication using gitlab token

    Steps:
        Send token to gitlab
        Verify that token is for user

    Args:
        gitlab_access_token:

    Returns:

    """


def auth_username_password(username, password):
    user = find_user(username)

    if user.verify_password(password=password):
        return user

    raise IncorrectPasswordError()
